<?php
require_once ('boConfig.php');

class boDb {
    function __construct() {
        $username = DB_USER;
        $password = DB_PASS;
        $servername = DB_HOST;
        $dbname = DB_NAME;
        $dbport = DB_PORT;

        // create connection
        $this->conn = mysqli_connect($servername, $username, $password, $dbname, $dbport);

        // check connection
        if (!$this->conn) {
            die("Connection failed: " . mysqli_connect_error() . "\n");
        }
    }

    function __destruct() {
        // close connection
        mysqli_close($this->conn);
        $this->conn = null;
    }

    function generiqSqlRequest($sql) {
        $data = null;
        $result = $this->conn->query($sql);
        if (1 == $result->num_rows) {
            $data = $result->fetch_assoc();
        } else if (1 < $result->num_rows) {
            $data = array();
            // read the data of each row
            while($row = $result->fetch_assoc()) {
                $data[] = $row;
            }
        }
        return($data);
    }

    function getSumOfStrokesPerChannel($minTime = null, $maxTime = null) {
        $sql = "SELECT count(*) as total";
        for($i=0; $i<count(CHANNEL_NUMBER); $i++) {
            $c = CHANNEL_NUMBER[$i];
            $sql .= ", sum(signals.channel$c) as sum$c";
        }
        $sql .= " FROM `signals`, `strokes`, `signals_strokes`";
        $sql .= " WHERE signals.id = signals_strokes.signal_id AND strokes.id = signals_strokes.stroke_id";
        if (!is_null($minTime)) {
            $sql .= " AND time_ns >= $minTime";
        }
        if (!is_null($maxTime)) {
            $sql .= " AND time_ns < $maxTime";
        }
        return($this->generiqSqlRequest($sql));
    }

    function getSumOfSignalsPerChannel($minTime = null, $maxTime = null) {
        $sql = "SELECT count(*) as total";
        for($i=0; $i<count(CHANNEL_NUMBER); $i++) {
            $c = CHANNEL_NUMBER[$i];
            $sql .= ", sum(channel$c) as sum$c";
        }
        $sql .= " FROM `signals`";
        $sql .= "  WHERE 1";
        if (!is_null($minTime)) {
            $sql .= " AND time_ns >= $minTime";
        }
        if (!is_null($maxTime)) {
            $sql .= " AND time_ns < $maxTime";
        }
        return($this->generiqSqlRequest($sql));
    }

    function getMaxDistanceStroke() {
        $sql = "SELECT max(distance) FROM `strokes` WHERE 1";
        return($this->generiqSqlRequest($sql));
    }

    function getSumOfStrokesPerDistancePerChannel($minDistance = null, $maxDistance = null) {
        $sql = "SELECT count(*) as total";
        for($i=0; $i<count(CHANNEL_NUMBER); $i++) {
            $c = CHANNEL_NUMBER[$i];
            $sql .= ", sum(signals.channel$c) as sum$c";
        }
        $sql .= " FROM `signals`, `strokes`, `signals_strokes`";
        $sql .= " WHERE signals.id = signals_strokes.signal_id AND strokes.id = signals_strokes.stroke_id";
        if (!is_null($minDistance)) {
            $sql .= " AND strokes.distance >= $minDistance";
        }
        if (!is_null($maxDistance)) {
            $sql .= " AND strokes.distance < $maxDistance";
        }
        return($this->generiqSqlRequest($sql));
    }

    function getStrokePositionForAllChannels() {
        $sql = "SELECT strokes.lat_stroke as lat";
        $sql .= ", strokes.lon_stroke as lon";
        for($i=0; $i<count(CHANNEL_NUMBER); $i++) {
            $c = CHANNEL_NUMBER[$i];
            $sql .= ", signals.channel$c as channel$c";
        }
        $sql .= " FROM `signals`, `strokes`, `signals_strokes`";
        $sql .= " WHERE signals.id = signals_strokes.signal_id AND strokes.id = signals_strokes.stroke_id";
        return($this->generiqSqlRequest($sql));
    }
}
?>