#!/usr/bin/python
from __future__ import print_function
from boConfig import FTP_LOCAL_PATH
import subprocess
import sys
import time

def generateDiagaram(params):
    tStart = time.time()
    cmd = "./boPng.php {}".format(params)
    sp = subprocess.Popen(cmd.split(), stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    out, err = sp.communicate()
    ext = None
    if ("" == err):
        if ("PNG" == out[1:4]):
            ext = "png"
        if ext:
            file = "{}/IMG{}.{}".format(FTP_LOCAL_PATH, "".join(i for i in params.split()), ext)
            with open(file, "wb") as f:
                f.write(out)
                print("{} > {}, {:.1f} sec".format(cmd, file, time.time() - tStart))
    else:
        print(err)
    return ext

def generateHtml(images):
    html = """<html>
    <head>
    </head>
    <body>
"""
    for params in images:
        html += "        <img src='IMG{}.png' />\n".format("".join(i for i in params.split()))
    html += """    </body>
</html>"""
    file = "{}/test.html".format(FTP_LOCAL_PATH)
    with open(file, "w") as f:
        f.write(html)
    print("{} > {}".format(sys.argv[0], file))

def main():
    paramsList = [ \
        "-d7",
        "-d1 -w320 -h240",
        "-d2 -w320 -h240",
        "-d3 -w320 -h240",
        "-d4 -w320 -h240",
        "-d6 -h480",
        "-d5 -c0 -h360",
        "-d5 -c1 -h360",
        "-d5 -c2 -h360",
        "-d5 -c3 -h360",
    ]
    if len(sys.argv) > 1:
        paramsList = [''.join("{} ".format(i) for i in sys.argv[1:])]
    images = []
    failed = ""
    for params in paramsList:
        ext = generateDiagaram(params)
        if ("png" == ext):
            images.append(params)
        else:
            print("'{}' failed".format(params))
    generateHtml(images)
    print("{} images generated".format(len(images)))

if __name__ == "__main__":
    main()
